package com.hfkj.dao;

import com.hfkj.entity.BsOrderOutside;
import com.hfkj.entity.BsOrderOutsideExample;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.hibernate.validator.constraints.NotEmpty;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsOrderOutsideMapper extends BsOrderOutsideMapperExt {
    @SelectProvider(type=BsOrderOutsideSqlProvider.class, method="countByExample")
    long countByExample(BsOrderOutsideExample example);

    @DeleteProvider(type=BsOrderOutsideSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsOrderOutsideExample example);

    @Delete({
        "delete from bs_order_outside",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int deleteByPrimaryKey(Integer id);

    @Insert({
        "insert into bs_order_outside (platform_code, platform_name, ",
        "login_type_code, login_type_name, ",
        "order_no, create_time, ",
        "update_time, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{platformCode,jdbcType=VARCHAR}, #{platformName,jdbcType=VARCHAR}, ",
        "#{loginTypeCode,jdbcType=VARCHAR}, #{loginTypeName,jdbcType=VARCHAR}, ",
        "#{orderNo,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsOrderOutside record);

    @InsertProvider(type=BsOrderOutsideSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsOrderOutside record);

    @SelectProvider(type=BsOrderOutsideSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="platform_code", property="platformCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="platform_name", property="platformName", jdbcType=JdbcType.VARCHAR),
        @Result(column="login_type_code", property="loginTypeCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="login_type_name", property="loginTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsOrderOutside> selectByExample(BsOrderOutsideExample example);

    @Select({
        "select",
        "id, platform_code, platform_name, login_type_code, login_type_name, order_no, ",
        "create_time, update_time, `status`, ext_1, ext_2, ext_3",
        "from bs_order_outside",
        "where id = #{id,jdbcType=INTEGER}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="platform_code", property="platformCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="platform_name", property="platformName", jdbcType=JdbcType.VARCHAR),
        @Result(column="login_type_code", property="loginTypeCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="login_type_name", property="loginTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsOrderOutside selectByPrimaryKey(Integer id);

    @UpdateProvider(type=BsOrderOutsideSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsOrderOutside record, @Param("example") BsOrderOutsideExample example);

    @UpdateProvider(type=BsOrderOutsideSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsOrderOutside record, @Param("example") BsOrderOutsideExample example);

    @UpdateProvider(type=BsOrderOutsideSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsOrderOutside record);

    @Update({
        "update bs_order_outside",
        "set platform_code = #{platformCode,jdbcType=VARCHAR},",
          "platform_name = #{platformName,jdbcType=VARCHAR},",
          "login_type_code = #{loginTypeCode,jdbcType=VARCHAR},",
          "login_type_name = #{loginTypeName,jdbcType=VARCHAR},",
          "order_no = #{orderNo,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int updateByPrimaryKey(BsOrderOutside record);
}